import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  ClassType,
  PropertyKeyType,
} from '@overflow/commons/core/type';

import {
  Injectable,
} from '@overflow/commons/di/decorators';

export interface WebApplicationAnnotationAttributes {
  jsonSources?: any[];
  injectables?: ClassType[];
  configurations?: ClassType[];
}

@Injectable()
export class WebApplicationAnnotation extends Annotation {
  public readonly attributes: WebApplicationAnnotationAttributes = {
  };

  public constructor(attributes: WebApplicationAnnotationAttributes) {
    super();
    this.copyAttributes(this.attributes, attributes);
  }

  public classDecorator<TFunction extends Function>(target: TFunction): TFunction | void {
    // no op
  }

}

export const WebApplication = Decorator.create(WebApplicationAnnotation);
